#ifndef __X10_IO_CONSOLE_H
#define __X10_IO_CONSOLE_H

#include <x10rt.h>


#define X10_LANG_OBJECT_H_NODEPS
#include <x10/lang/Object.h>
#undef X10_LANG_OBJECT_H_NODEPS
namespace x10 { namespace io { 
class OutputStreamWriter__OutputStream;
} } 
namespace x10 { namespace compiler { 
class Native;
} } 
namespace x10 { namespace io { 
class InputStreamReader__InputStream;
} } 
namespace x10 { namespace io { 
class Printer;
} } 
namespace x10 { namespace io { 
class Writer;
} } 
namespace x10 { namespace io { 
class OutputStreamWriter;
} } 
namespace x10 { namespace compiler { 
class PerProcess;
} } 
namespace x10 { namespace io { 
class Reader;
} } 
namespace x10 { namespace io { 
class InputStreamReader;
} } 
namespace x10 { namespace io { 

class Console : public x10::lang::Object   {
    public:
    RTT_H_DECLS_CLASS
    
    static x10aux::ref<x10::io::Printer> FMGL(OUT);
    
    static x10aux::ref<x10::io::Printer> FMGL(OUT__get)();
    static x10aux::ref<x10::io::Printer> FMGL(ERR);
    
    static x10aux::ref<x10::io::Printer> FMGL(ERR__get)();
    static x10aux::ref<x10::io::Reader> FMGL(IN);
    
    static x10aux::ref<x10::io::Reader> FMGL(IN__get)();
    virtual x10aux::ref<x10::io::Console> x10__io__Console____x10__io__Console__this(
      );
    void _constructor();
    
    static x10aux::ref<x10::io::Console> _make();
    
    
    // Serialization
    public: static const x10aux::serialization_id_t _serialization_id;
    
    public: virtual x10aux::serialization_id_t _get_serialization_id() {
         return _serialization_id;
    }
    
    public: virtual void _serialize_body(x10aux::serialization_buffer& buf);
    
    public: static x10aux::ref<x10::lang::Reference> _deserializer(x10aux::deserialization_buffer& buf);
    
    public: void _deserialize_body(x10aux::deserialization_buffer& buf);
    
};

} } 
#endif // X10_IO_CONSOLE_H

namespace x10 { namespace io { 
class Console;
} } 

#ifndef X10_IO_CONSOLE_H_NODEPS
#define X10_IO_CONSOLE_H_NODEPS
#include <x10/lang/Object.h>
#include <x10/io/OutputStreamWriter__OutputStream.h>
#include <x10/compiler/Native.h>
#include <x10/io/InputStreamReader__InputStream.h>
#include <x10/io/Printer.h>
#include <x10/io/Writer.h>
#include <x10/io/OutputStreamWriter.h>
#include <x10/compiler/PerProcess.h>
#include <x10/io/Reader.h>
#include <x10/io/InputStreamReader.h>
#ifndef X10_IO_CONSOLE_H_GENERICS
#define X10_IO_CONSOLE_H_GENERICS
inline x10aux::ref<x10::io::Printer> x10::io::Console::FMGL(OUT__get)() {
    return x10::io::Console::FMGL(OUT);
}

inline x10aux::ref<x10::io::Printer> x10::io::Console::FMGL(ERR__get)() {
    return x10::io::Console::FMGL(ERR);
}

inline x10aux::ref<x10::io::Reader> x10::io::Console::FMGL(IN__get)() {
    return x10::io::Console::FMGL(IN);
}

#endif // X10_IO_CONSOLE_H_GENERICS
#endif // __X10_IO_CONSOLE_H_NODEPS
